INCLUDED4:EFT36S.ASM
;
;EFT  VERSION 36T (THINKING ROUTINES) JANUARY 29, 1983
;
;calculate individual force ratios
;
ARTAILDA#$FF
STASDIR
LDX#NOUNTS
LOOP50STXARMY
LDAARRIVE,X
CMPTURN
BCSY44
JSRCALIFR
LDACORPSX,X
STAOBJX-NOGERM,X
LDACORPSY,X
STAOBJY-NOGERM,X
Y44DEX
CPX#NOGERM
BCSLOOP50
;
;here begins the main loop
;
MLOOPLDX#NOUNTS;outer loop for entire Russian army
LOOP51STXARMY;inner loop for individual armies
LDAARRIVE,X
CMPTURN
BCCZ26
Z54JMPTOGSCN
Z26LDACORPT,X
CMP#$81
BEQZ54
LDACLOSE-NOGERM,X
CMP#CRITRG;close to front?
BCCY51
LDAOFR;no, reinforcement
LSRA
STABVAL
;
;find nearby beleaguered army
;
LDALEVEL
CMP#4
BNEZ47
LDA#2
STAMODE,X
Z47LDY#NOUNTS
LOOP52LDAARRIVE,Y
CMPTURN
BCSY54
LDA#0
JSRDELRG2
LSRA
STATEMPR
LDAIFR-NOGERM,Y
SEC
SBCTEMPR
BCCY54;no good using distant armies
CMPBVAL
BCCY54
STABVAL
STYBONE
Y54DEY
CPY#NOGERM
BCSLOOP52
LDAOFR
LSRA
CMPBVAL
BNEX74
LDACLOSE1-NOGERM,X
STABONE
X74LDYBONE;beleagueredest army
LDACORPSX,Y
STAOBJX-NOGERM,X
LDACORPSY,Y
STAOBJY-NOGERM,X
JMPTOGSCN
;
;front line armies
;
Y51LDA#$FF
STADIR;a direction of $FF means 'stay put'
STABONE
LDA#0
STABVAL
;
;ad hoc logic for surrounded people
;
LDAMSTRNG,X
LSRA
CMPCSTRNG,X
BCCZ56
LDALEVEL
CMP#4
BCCZ55
JSRSETLAT
JSRCHKZOC
LDAZOC
CMP#2
BCCZ55
LDA#3
STAMODE,X
JMPTOGSCN
Z56LDAIFRE-NOGERM,X
ASLA
ADCOFR
CMP#$30
BCCDRLOOP
Z55LDACORPSX,X;head due east!
SEC
SBC#5
BCSZ96
LDA#0
Z96STAOBJX-NOGERM,X
JMPTOGSCN
DRLOOPJSRGETCON
ANDSDIR
STASDIR
LDAOBJX-NOGERM,X
LDYDIR
BMIY55
CLC
ADCXINC,Y
Y55STATARGX
LDAOBJY-NOGERM,X
LDYDIR
BMIY56
CLC
ADCYINC,Y
Y56STATARGY
LDA#0
STASQVAL
LDADIR
BMIY57
STAWHORDS,X
JSRY00
LDYARMY
LDAEXEC,Y;is square accessible?
BPLY57;yes
JMPEVALSQ;no, skip this square
;
;now fill in the direct line array
;
Y57LDATARGX
STALONG
LDATARGY
STALAT
LDY#$17
LOOP56STYTEMPR
LDAJSTP,Y
JSRFIGMOV+5
;
LDX#NOUNTS
LOOP55LDAARRIVE,X
CMPTURN
BEQZ25
BCSY58
Z25LDAOBJX-NOGERM,X
CMPLONG
BNEY58
LDAOBJY-NOGERM,X
CMPLAT
BNEY58
CPXARMY
BEQY31
LDAMSTRNG,X
BNEY59
Y58DEX
CPX#NOGERM
BCSLOOP55
Y31LDA#0
Y59LDYTEMPR
LDXNDX,Y
STALINARR,X
DEY
BPLLOOP56
;
LDXARMY
LDAMSTRNG,X
STALINARR+12
LDA#0
STAACCLO
STAACCHI
STASECDIR
;
;build LV array
;
Y88LDX#0
STXTEMPR
Y92LDY#0
Y90LDALINARR,X
BNEY89
INX
INY
CPY#5
BNEY90
Y89LDXTEMPR
TYA
STALV,X
INX
STXTEMPR
CPX#1
BNEY91
LDX#5
BNEY92
Y91CPX#2
BNEY93
LDX#$A
BNEY92
;
Y93CPX#3
BNEZ40
LDX#$F
BNEY92
Z40CPX#4
BNEZ41
LDX#$14
BNEY92
;
Z41LDA#0
LDY#4
LOOP76LDXLV,Y
CPX#5
BEQZ42
CLC
ADC#$28
Z42DEY
BPLLOOP76
;
;now add bonus if central column is otherwise empty
;
LDYLINARR+10
BNEY95
LDYLINARR+11
BNEY95
LDYLINARR+13
BNEY95
LDYLINARR+14
BNEY95
CLC
ADC#$30
Y95STALPTS
;
;now evaluate blocking penalty
;
LDX#0
LOOP72LDALV,X
CMP#4
BCSY96
STATEMPR
STXTEMPD
TXA
ASLA
ASLA
ADCTEMPD
ADCTEMPR
TAY
INY
LDALINARR,Y
BEQY96
LDALPTS
SEC
SBC#$20
BCSA91
LDA#0
A91STALPTS
Y96INX
CPX#5
BNELOOP72
;
;now evaluate vulnerability to penetrations
;
LDY#0
LOOP54STYTEMPY
LDX#0
LOOP73STXTEMPX
CPXTEMPY
BEQNXCLM
LDALV,X
SEC
SBCLV,Y
BEQNXCLM
BMINXCLM
TAX
LDA#1
LOOP74ASLA
DEX
BNELOOP74
STATEMPR
LDALPTS
SEC
SBCTEMPR
BCSY32
LDA#0
Y32STALPTS
NXCLMLDXTEMPX
INX
CPX#5
BNELOOP73
INY
CPY#5
BNELOOP54
;
;now get overall line value weighted by danger vector
;
LDXARMY
LDYSECDIR
BNEZ18
LDAIFRN-NOGERM,X
JMPZ20
Z18CPY#1
BNEZ19
LDAIFRE-NOGERM,X
JMPZ20
Z19CPY#2
BNEZ17
LDAIFRS-NOGERM,X
JMPZ20
Z17LDAIFRW-NOGERM,X
Z20STATEMPR
LDXLPTS
BEQZ49
LDAACCLO
CLC
LOOP75ADCTEMPR
BCCY34
INCACCHI
CLC
BNEY34
LDA#$FF
STAACCHI
Y34DEX
BNELOOP75
;
;next secondary direction
;
Z49INY
CPY#4
BEQY35
STYSECDIR
;
;rotate array
;
LDX#$18
LOOP70LDALINARR,X
STABAKARR,X
DEX
BPLLOOP70
LDX#$18
LOOP71LDYROTARR,X
LDABAKARR,X
STALINARR,Y
DEX
BPLLOOP71
JMPY88
;
;
Y35LDAACCHI
STASQVAL
;
;get range to closest German into NBVAL
;
LDX#NOGERM-1
LDA#$FF
STANBVAL
STACHRIS
LOOP59LDAARRIVE,X
CMPTURN
BEQY61
BCSY68
Y61JSRTARGRG
BNEZ57
STXCHRIS
Z57CMPNBVAL
BCSY68
STANBVAL
Y68DEX
BPLLOOP59
;
;now determine whether to use offensive or defensive strategy
;
LDXARMY
LDAIFR-NOGERM,X
STATEMPR
LDA#$F
SEC
SBCTEMPR
BCCA40
ASLA;OK, let's fool the routine
STATEMPR
LDYNBVAL
BEQZ39
LDA#CRITRG
SEC
SBCNBVAL;I know that NBVAL<CRITRG for all front line units
STANBVAL
;
;now add NBVAL*IFR to SQVAL with defensive bonus
;
A40LDYNBVAL
BNEZ24;this square occupied by a German?
LDXCHRIS
CPX#NOFLIG
BCSZ39
LDAMSTRNG,X
LSRA
CMPCSTRNG,X
BCCZ43
Z39DEY;invert meaning
Z43STYSQVAL
JMPEVALSQ
Z24LDYTRNTYP
LDADEFNC,Y
CPY#2
BNEZ36
LDYTRNCOD
BMIZ36
ASLA
CPY#74
BNEZ38
LDA#$FF
STASQVAL
JMPEVALSQ
Z38CPY#73
BNEZ36
LDA#8
Z36ASLA
CLC
ADCTEMPR
STATEMPR
LDYNBVAL
LDA#0
CLC
LOOP60ADCTEMPR
BCCY69
LDA#$FF
BMIY71
Y69DEY
BNELOOP60
;
Y71CLC
ADCSQVAL
BCCX00
LDA#$FF
X00STASQVAL
;
;extract penalty if somebody else has dibs on this square
;
LDYDIR
BMIZ91
LDX#NOUNTS
LOOP58LDAARRIVE,X
CMPTURN
BEQNZ44
BCSZ44
NZ44JSRTARGRG
BNEZ44
CPXARMY
BEQZ44
STASQVAL
BNEEVALSQ
Z44DEX
CPX#NOGERM
BCSLOOP58
;
;now extract distance penalty
;
Z91LDXARMY
JSRTARGRG
ASLA
ASLA
ASLA
JSRSUBSQV
;
;now evaluate this square
;
EVALSQLDYDIR
LDXARMY
LDASQVAL
CMPBVAL
BCCY72
STABVAL
STYBONE
Y72INY
CPY#4
BEQY73
STYDIR
JMPDRLOOP
;
Y73LDAOBJX-NOGERM,X
LDYBONE
BMIY74
CLC
ADCXINC,Y
Y74STAOBJX-NOGERM,X
LDAOBJY-NOGERM,X
LDYBONE
BMIY75
CLC
ADCYINC,Y
Y75STAOBJY-NOGERM,X
;
;
TOGSCNLDATRIG0
BEQX24;ignore game console if red button is down
JSRGETCON
ANDSDIR
AND#4
BNEX24
;
LDX#NOZPVL
LOOP27LDADLSTPT,X
STAZPVAL,X
DEX
BPLLOOP27
;
LDA#8
LDX#$B
JSRCALCIO
LDATEMPD
BMIY97
JSRAFTCIO
Y97LDASHPOS0
STAHPOSP0
X24JSRGETCON
ANDSDIR
AND#1
BNEY66
LDAPASFLG
BNEWRAPUP
LDX#8
STXNRDYFG
JSRERR1
Y66LDA#$FF
STASDIR
LDXARMY
DEX
CPX#NOGERM
BCCY76
JMPLOOP51
Y76STXPASFLG
LDANRDYFG
BEQY98
LDA#0
STANRDYFG
LDX#9
JSRERR1
Y98JMPMLOOP
;
WRAPUPLDX#NOUNTS
LOOP62STXARMY
LDAARRIVE,X
CMPTURN
BCCY78
JMPY77
Y78LDAOBJX-NOGERM,X
CMPCORPSX,X
BNEZ92
LDACORPSY,X
CMPOBJY-NOGERM,X
BNEZ92
LDALEVEL
CMP#4
BNEZ92
LDA#3
STAMODE,X
Z92LDAOBJX-NOGERM,X
LDY#3
SEC
SBCCORPSX,X
BPLY79
LDY#1
JSRINVERT+2
Y79STYHDIR
STAHRNGE
LDY#0
LDAOBJY-NOGERM,X
SEC
SBCCORPSY,X
BPLY80
LDY#2
JSRINVERT+2
Y80CMPHRNGE
BCCY81
STALRNGE
LDAHRNGE
STASRNGE
LDAHDIR
STASDIR
STYLDIR
JMPY82
Y81STASRNGE
STYSDIR
LDAHRNGE
STALRNGE
LDYHDIR
STYLDIR
Y82LDA#0
STARCNT
STARORD1
STARORD2
LDALRNGE
CLC
ADCSRNGE
STARANGE
BEQY86
LDALRNGE
LSRA
STACHRIS
;
LOOP61LDACHRIS
CLC
ADCSRNGE
STACHRIS
SEC
SBCRANGE
BCSOVRFLO
LDALDIR
BCCSTIP
OVRFLOSTACHRIS
LDASDIR
STIPSTADIR
LDARCNT
AND#3
TAY
STATEMPR
LDARCNT
LSRA
LSRA
TAX
LDADIR
Y85DEY
BMIY84
ASLA
ASLA
JMPY85
;
Y84LDYTEMPR
EORRORD1,X
ANDMASKO,Y
EORRORD1,X
STARORD1,X
INCRCNT
LDXRCNT
CPX#8
BCSY86
CPXRANGE
BCCLOOP61
Y86LDXARMY
LDARORD1
STAWHORDS,X
LDARORD2
STAWHORDH,X
LDARCNT
STAHMORDS,X
;
Y77DEX
CPX#NOGERM
BCCY87
JMPLOOP62
Y87RTS
;
;
DL2DB$70,$70,$70,$70,$70,$70,$70
DB$70,$70,$70,$47
DWSCNDAT
DB$70,7,7,$41
DWDL2
SCNDATDB0,0,0,0,0
DB'please'
DB0
DB'wait'
DB0,0,0,0,0,0
DB$30,$32,$25,$33,$33,0
DB$32,$25,$34,$35,$32,$2E,0
DB$37,$28,$25,$2E,0,0,0,0,0
DB$39,$2F,$35,0,$21,$32,$25,0
DB$32,$25,$21,$24,$39,0,0,0
;
SETDLSLDA#$2F
STASDMCTL
LDA#$6A
STA$2C4
LDA#DLIST&$FF
STADLSTLO
LDA#DLIST/256
STADLSTHI
RTS
;
;subroutine CALCIO
;
CALCIOSTAICAX12
STXTEMPR
LDA#0
STATEMPD
STAHPOSP0
STAHPOSP1
STAHPOSP2
STAHPOSP3
LDA#DL2&$FF
STADLSTLO
LDA#DL2/256
STADLSTHI
LDA#$22
STASDMCTL
LDA#$B0
STA$2C4
LDA#$40
STANMIEN
LDY#XITVBV&$FF
LDX#XITVBV/256
LDA#7
JSRSETVBV
LDA#2
JSRSTALL
LDA#FILENM&$FF
STAICBAL2
LDA#FILENM/256
STAICBAH2
LDA#0
STAICAX22
LDA#3
JSRGOCIO
BPLX48
CPY#130
BNEZ31
LDA#$38
STA$2C4
LDA#$C
JSRGOCIO
LDA#CASNAM&$FF
STAICBAL2
LDA#CASNAM/256
STAICBAH2
LDA#$80
STAICAX22
LDA#$FF
STACH
LDA#3
JSRGOCIO
BPLX48
Z31JSRERROR
JMPCLOCIO
X48LDA#MAPDAT&$FF
STAICBAL2
LDA#MAPDAT/256
STAICBAH2
LDA#[MOSCOW+18-MAPDAT]&$FF
STAICBLL2
LDA#[MOSCOW+18-MAPDAT]/256
STAICBLH2
LDATEMPR
JSRGOCIO
BPLCLOCIO
JSRERROR
CLOCIOLDA#$C
JSRGOCIO
LDA#3
STASKCTL
TYA
BMIERROR
AFTCIOJSRSETDLS
RESVBILDY#VBISRV&$FF
LDX#VBISRV/256
LDA#7
JSRSETVBV
LDA#$C0
STANMIEN
RTS
;
GOCIOSTAICCMD2
LDX#$20
JMPCIOV
;
ERRORJSRAFTCIO
LDX#4
JSRERR1
DEY
LDAICSTA2
JSRDNUMBR
LDA#$FF
STATEMPD
JSRSTALL
JSRWDWCLR
RTS
;
;Subroutine CALIFR determines individual force ratios
;in all four directions
;
CALIFRLDA#0;initialize vectors
STAIFR0
STAIFR1
STAIFR2
STAIFR3
STAIFRHI
STAMODE,X
LDA#1
STARFR
JSRSETLAT
LDY#NOUNTS
STYBVAL
LOOP53LDAARRIVE,Y
CMPTURN
BEQZ28
BCCZ28
JMPY48
Z28LDACORPSY,Y
SEC
SBCLAT
STATEMPY;save signed vector
JSRINVERT
STATEMPR
LDACORPSX,Y
SEC
SBCLONG
STATEMPX
JSRINVERT
CLC
ADCTEMPR
CMPBVAL
BCSZ07
CPY#NOGERM
BCSZ07
STABVAL
STYBONE
Z07STATEMPR;this is range to unit
;
;now select which IFR gets this German
;
LDATEMPX
BPLX27
LDATEMPY
BPLZ01
LDX#1
CMPTEMPX
BCSZ02
LDX#2
BCCZ02
X27LDATEMPY
BPLZ03
JSRINVERT+2
LDX#2
CMPTEMPX
BCSZ02
LDX#3
BCCZ02
Z03LDX#0
CMPTEMPX
BCSZ02
LDX#3
BCCZ02
Z01LDATEMPX
JSRINVERT+2
LDX#1
CMPTEMPY
BCSZ02
LDX#0
Z02LDACSTRNG,Y
LOOP67LSRA
BEQY48;save some time
DECTEMPR
BPLLOOP67
CPY#NOGERM
BCCZ12
CLC
ADCRFR
BCCZ13
LDA#$FF
Z13STARFR
JMPY48
Z12CLC
ADCIFR0,X
BCCZ05
LDA#$FF
Z05STAIFR0,X
Y48DEY
BEQZ06
JMPLOOP53
;
Z06LDX#3
LDA#0
Y37CLC
ADCIFR0,X
BCCY36
LDA#$FF
Y36DEX
BPLY37
;
;
ASLA
ROLIFRHI
ASLA
ROLIFRHI
ASLA
ROLIFRHI
ASLA
ROLIFRHI
LDX#0
SEC
Z16SBCRFR
BCSZ14
DECIFRHI
SEC
BMIZ15
Z14INX
JMPZ16
Z15TXA
LDXARMY
CLC
ADCOFR;remember strategic situation
RORA;average strategic with tactical
STAIFR-NOGERM,X
;
;keep a record of danger vector
;
LDAIFR0
STAIFRN-NOGERM,X
LDAIFR1
STAIFRE-NOGERM,X
LDAIFR2
STAIFRS-NOGERM,X
LDAIFR3
STAIFRW-NOGERM,X
LDABVAL
STACLOSE-NOGERM,X
LDABONE
STACLOSE1-NOGERM,X
RTS
;
;this subroutine determines the type of terrain
;in a square
;
TERRTYLDY#0
LDATRNCOD
BEQDONE
CMP#$7F;border?
BNEY04
LDY#9
BNEDONE
Y04INY
CMP#7;mountain?
BCCDONE
INY
CMP#$4B;city?
BCCDONE
CMP#$C0
BCSDONE
INY
CMP#$4F;frozen swamp?
BCCDONE
INY
CMP#$69;frozen river?
BCCDONE
INY
CMP#$8F;swamp?
BCCDONE
INY
CMP#$A4;river?
BCCDONE
LDXLAT
CPX#$E
BCCNEXT
CMP#$A9
BCCDONE
NEXTINY
CMP#$BA;coastline?
BCCDONE
CPX#$E
BCCNEXT2
CMP#$BB
BCCDONE
NEXT2INY
CMP#$BD;estuary?
BCCDONE
INY
DONESTYTRNTYP
RTS
;
INVERTBPLZ46
EOR#$FF
CLC
ADC#1
Z46RTS
